#!/usr/bin/env python
# -*- coding: utf-8 -*-

"""
 * ------------------------------------------------------------------------
 * bmTraces
 * ------------------------------------------------------------------------
 * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>
 * @author  : Pascal SALAUN 
 * @Website : http://www.bm-stats.org <http://www.bm-stats.org>
 * ------------------------------------------------------------------------
"""

# Native Python Lib/Class 
from Tkinter import *
import ttk

# bmTraces Class 
from Alert import *
import configVar as config
from cypherTools import *
from initFrames import *
from logger import *
from sqlQuery import *


class bmTraceUsers:

        def __init__(self, *args, **kwargs):
               
                if "parent" in kwargs.keys():
                        parentW = kwargs["parent"]
                else:
                        parentW = self.fenetre
                        
                        
                if "me" in kwargs.keys():
                        self.me = kwargs["me"]
                        
                usersDb  = config.USERDB        
                        
                self.fenetre = parentW

                self.traceU = logger()
                self.cDb  = sqlQuery(usersDb)

             
                
        def getAllUser(self):
                self.thisListOfUser = self.cDb.getAllUser()



        def treeviewSortColumn(self, tv, col, reverse):
                l = [(tv.set(k, col), k) for k in tv.get_children('')]
                l.sort(key=lambda t: t[0], reverse=reverse)
                
                for index, (val, k) in enumerate(l):
                        tv.move(k, '', index)
                        
                tv.heading(col,command=lambda: self.treeviewSortColumn(tv, col, not reverse))



        def showAllUser(self):
                titleLeft = "  List of User(s) "
                i2f = initFrames(self.fenetre)                
                i2f.init2Frames(case="user", titleLeftLabelFrame=titleLeft,) 
                self.left  = i2f.left
                self.right = i2f.right
                
                self.getAllUser()
                self.displayAllUser()


        def displayAllUser(self):
                left = self.left 
             
                                
                scrollbar = Scrollbar(left)
                scrollbar.pack( side = RIGHT, fill=Y )

                columns = ('User')
                
                self.treeview = ttk.Treeview(self.left , height=50, columns=columns, show='headings',)
                self.treeview['yscroll'] = scrollbar.set
        
                       
                for tupl in self.thisListOfUser:
                        self.treeview.insert('', END, values=tupl, text=tupl[0])

                self.treeview.pack()
                scrollbar.config( command = self.treeview.yview )
                
                self.treeview.heading('User', text='User', command=lambda: self.treeviewSortColumn(self.treeview, 'User', False))
                self.treeview.column('User',minwidth=0,width=400,)

                
                self.treeview.bind("<Double-1>", self.displayThis)        

        def addUser(self, *args):
                
                login = self.login.get()
                pwd1  = self.password.get()
                pwd2  = self.passwordConfirm.get()
        
                if self.cDb.verifyIfExists((login,)) is False:
                        Alert().showinfo('Sorry for you', 'This user already exists !')
        
                elif pwd1!=pwd2:
                        Alert().showinfo('Sorry for you', 'The passwords must be the same')
                elif len(pwd1) < 8:
                        Alert().showinfo('Sorry for you', 'The password must contain at least 8 char.')
                else:
                        c = cypherTools()
                        cypheredPwd = c.cypher(pwd1)
                        tupl = (login, cypheredPwd)
                        res = self.cDb.addUser(tupl)
                        log = "Request by : " + self.me + ", Action : addUser " + login
                        self.traceU.add("info", log)
                        
                        self.showAllUser()
                        
                        if res == 0:
                                
                                Alert().showinfo('Success', 'This new user is now saved ')                           
                        else:
                                Alert().showerror('Sorry for you', 'This new user is not saved !')   
                                
        
        def delUser(self, *args):
               who = args[0]
               by  = args[1]
               
               if Alert().askyesno('Delete user ' + who, 'Are sure of this ? Really sure ?'):
                        tupl = (who,)
                        res = self.cDb.deleteUser(tupl)
                        if res == 0:
                                log = "Request by : " + by + ", Action : delUser " + who
                                self.traceU.add("info", log)
                                self.showAllUser()
                                

        def updatePassword(self, *args):
                who  = args[0]
                by   = args[1]
                
                pwd1 = self.newPassword.get()
                pwd2 = self.newPasswordConfirm.get()
                
                if pwd1!=pwd2:
                        Alert().showinfo('Sorry for you', 'The passwords must be the same')
                elif len(pwd1) < 8:
                        Alert().showinfo('Sorry for you', 'The password must contain at least 8 char.')
                else:
                        c = cypherTools()
                        cypheredPwd = c.cypher(pwd1)
                        tupl = (cypheredPwd, who)
                        res = self.cDb.updatePasswordUser(tupl)
                        
                                              
                        if res == 0:
                                log = "Request by : " + by + ", Action : updatePassword for " + who
                                self.traceU.add("info", log)
                                                             
                                Alert().showinfo('Success', 'The new password is now saved ')

                        else:
                                Alert().showerror('Sorry for you', 'The new password is not saved !')
                                
                                
        def displayThis(self, event):
                
                for instance in self.right.winfo_children():
                        if isinstance(instance, ttk.Notebook):
                                instance.destroy()
                                
                item = self.treeview.identify('item',event.x,event.y)
                user = self.treeview.item(item,"text") 
                
                self.tab = ttk.Notebook(self.right)
                self.tab.pack(fill='both', expand=True)

                self.tab1 = ttk.Frame(self.tab)
                self.tab2 = ttk.Frame(self.tab)
                
                
                
                """
                tab 1 : update password
                """
                self.tab.add(self.tab1,  compound='left', text='Change ' + user + ' Password')
             
                Label(self.tab1, text="").grid(row=0, column=0, padx=5, pady=5)
                Label(self.tab1, text="").grid(row=0, column=1, columnspan=2,padx=5, pady=5)
                
                Label(self.tab1, text="New password : ").grid(row=1, column=1, sticky="e")
                self.newPassword = Entry(self.tab1, show = '*')
                self.newPassword.grid(row=1, column=2 )
                
                Label(self.tab1, text="Repeat password : ").grid(row=2, column=1, sticky="e")
                self.newPasswordConfirm = Entry(self.tab1, show = '*')
                self.newPasswordConfirm.grid(row=2, column=2)
                                
                Label(self.tab1, text="").grid(row=3, columnspan=2,padx=5, pady=5)
                     
                     
                validButton = Button(self.tab1, text="Update Password", command=lambda who=user, by=self.me : self.updatePassword(who, by))
                validButton.grid(row=4, column=1, columnspan=2, sticky="nwes")
                
                """
                tab 2 : delete user
                """  
                                
                if user != 'admin':
                        self.tab.add(self.tab2, text='Delete ' + user + ' !')
                        Label(self.tab2, text="").grid(row=0, column=0, padx=5, pady=5)
                        Label(self.tab2, text="").grid(row=0, column=1, columnspan=2,padx=5, pady=5)
                        
                        delButton = Button(self.tab2, text="Delete this User", command=lambda who=user, by=self.me : self.delUser(who, by))
                        delButton.grid(row=4, column=1, columnspan=2, sticky="nwes")
                        
           
           
        def displayPasswordForm(self, *args, **kwargs):
                
                if "me" in kwargs.keys():
                        me = kwargs["me"]
                
                if "user" in kwargs.keys():
                        user = kwargs["user"]
                
                
                i1f = initFrames(self.fenetre)                
                i1f.init1Frame() 
                self.left  = i1f.pane
                
                self.tab = ttk.Notebook(self.left)
                self.tab.pack(fill='both', expand=True)

                self.tab1 = ttk.Frame(self.tab)

                
                
                """
                tab 1 : update password
                """
                self.tab.add(self.tab1,  compound='left', text='Change ' + user + ' Password')
             
                Label(self.tab1, text="").grid(row=0, column=0, padx=5, pady=5)
                Label(self.tab1, text="").grid(row=0, column=1, columnspan=2,padx=5, pady=5)
                
                Label(self.tab1, text="New password : ").grid(row=1, column=1, sticky="e")
                self.newPassword = Entry(self.tab1, show = '*')
                self.newPassword.grid(row=1, column=2 )
                
                Label(self.tab1, text="Repeat password : ").grid(row=2, column=1, sticky="e")
                self.newPasswordConfirm = Entry(self.tab1, show = '*')
                self.newPasswordConfirm.grid(row=2, column=2)
                                
                Label(self.tab1, text="").grid(row=3, columnspan=2,padx=5, pady=5)
                     
                     
                validButton = Button(self.tab1, text="Update Password", command=lambda who=user, by=me : self.updatePassword(who, by))
                validButton.grid(row=4, column=1, columnspan=2, sticky="nwes")
               
               
               
        def displayAddUserForm(self, *args, **kwargs):
                
                i1f = initFrames(self.fenetre)                
                i1f.init1Frame() 
                self.left  = i1f.pane
                                
                for instance in self.left.winfo_children():
                        if isinstance(instance, ttk.Notebook):
                                instance.destroy()
                
                self.tab = ttk.Notebook(self.left)
                self.tab.pack(fill='both', expand=True)

                self.tab1 = ttk.Frame(self.tab)

                self.tab.add(self.tab1,  compound='left', text='Add an user')
             
                Label(self.tab1, text="").grid(row=0, column=0, padx=5, pady=5)
                Label(self.tab1, text="").grid(row=0, column=1, columnspan=2,padx=5, pady=5)
                
                Label(self.tab1, text="Login : ").grid(row=1, column=1, sticky="e")
                self.login = Entry(self.tab1,)
                self.login.grid(row=1, column=2 )
                
                Label(self.tab1, text="Password : ").grid(row=2, column=1, sticky="e")
                self.password = Entry(self.tab1, show = '*')
                self.password.grid(row=2, column=2 )
                
                Label(self.tab1, text="Repeat password : ").grid(row=3, column=1, sticky="e")
                self.passwordConfirm = Entry(self.tab1, show = '*')
                self.passwordConfirm.grid(row=3, column=2)
                                
                Label(self.tab1, text="").grid(row=4, columnspan=2,padx=5, pady=5)
                                    
                validButton = Button(self.tab1, text="Add this User", command=lambda : self.addUser(self.me))
                validButton.grid(row=4, column=1, columnspan=2, sticky="nwes")
                
 
                
                