#!/usr/bin/env python
# -*- coding: utf-8 -*-

"""
 * ------------------------------------------------------------------------
 * bmTraces
 * ------------------------------------------------------------------------
 * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>
 * @author  : Pascal SALAUN 
 * @Website : http://www.bm-stats.org <http://www.bm-stats.org>
 * ------------------------------------------------------------------------
"""

# Native Python Lib/Class 
from Tkinter import * 
import tkSimpleDialog 
import ttk
import thread
import threading
import time

# bmTraces Class
from Alert import *
from authDialog import *
from bmTraceUsers import *
import configVar as config
from displayAbout import *
from initFrames import *
from logger import *
from mailLogParser import *
from searchDialog import *
from sqlQuery import *
from viewData import *
from waitForTask import *



class bmTraces:

        control       = 'ko'
        usersDb       = config.USERDB
        userOwnDbPath = config.USEROWNDBPATH
        
        #usersDb       = "/var/lib/bmTraces/db/users.db"
        #userOwnDbPath = "/var/lib/bmTraces/db/"
        
        def __init__(self):
                self.fenetre = Tk()
                self.fenetre.geometry("1100x600+50+50")
                self.fenetre.wm_title("bmTraces : Search in Postfix mail logs ")
                self.fenetre['bg']='#002E6A'
                
                self.mainLogo=PhotoImage(file="./images/bmTracesMain.gif")
                self.backgroundImg = Label(self.fenetre, image=self.mainLogo, bd=0)
                self.backgroundImg.place(x=0, y=0, relwidth=1, relheight=1)
                self.backgroundImg.pack()
                
                self.trace = logger()
                                
        def start(self):
                self.initIcons()
                self.initMenu(self.control)
                self.loop()

        def loop(self):
                self.fenetre.mainloop()

        def about(self):
                displayAbout()
                
        def initIcons(self):
                self.iconLogin=PhotoImage(file="./images/login.gif")
                self.iconLogout=PhotoImage(file="./images/logout.gif")
                self.iconInbox=PhotoImage(file="./images/inbox.gif")
                self.iconOutbox=PhotoImage(file="./images/outbox.gif")
                self.iconText=PhotoImage(file="./images/text.gif")
                self.iconUserList=PhotoImage(file="./images/userList.gif")
                self.iconUserAdd=PhotoImage(file="./images/userAdd.gif")
                self.iconUserDelete=PhotoImage(file="./images/userDelete.gif")
                self.iconUserReset=PhotoImage(file="./images/userReset.gif")
                self.iconSearch=PhotoImage(file="./images/search.gif")
                

        def initMenu(self, control):
                self.initIcons()
                
                menubar = Menu(self.fenetre)

                menu1 = Menu(menubar, tearoff=0)
                if control == "ko":
                        menu1.add_command(label="Log in", image=self.iconLogin, compound="left", command=self.authBox)
                        menu1.add_separator()
                        
                menu1.add_command(label="Quit", image=self.iconLogout, compound="left", command=self.fenetre.destroy)
                menubar.add_cascade(label="File", menu=menu1)

                if control == "ok":
                        menu2 = Menu(menubar, tearoff=0)
                        menu2.add_command(label="An Address", image=self.iconInbox, compound="left", command=lambda what='address': self.searchBox(what))
                        menu2.add_command(label="A Sender", image=self.iconInbox, compound="left", command=lambda what='from': self.searchBox(what))
                        menu2.add_command(label="A Recipient", image=self.iconOutbox, compound="left", command=lambda what='recip': self.searchBox(what) )
                        menu2.add_command(label="A message-id", image=self.iconText, compound="left", command=lambda what='messageid': self.searchBox(what))
                        menubar.add_cascade(label="Search", menu=menu2)

                        if self.thisUser == 'admin':
                                menu3 = Menu(menubar, tearoff=0)
                                menu3.add_command(label="List", image=self.iconUserList, compound="left", command=lambda : self.bmTraceUsersList() )
                                menu3.add_command(label="Add", image=self.iconUserAdd, compound="left", command=lambda : self.bmTraceAddUser() )
                                menu3.add_command(label="Edit yours !", image=self.iconUserReset, compound="left", command=lambda : self.bmTraceEditMyProfile(self.me) )
                                menubar.add_cascade(label="Profiles", menu=menu3)
                        else:
                                menu3 = Menu(menubar, tearoff=0)
                                menu3.add_command(label="Edit it !", image=self.iconUserReset, compound="left", command=lambda : self.bmTraceEditMyProfile(self.me) )
                                menubar.add_cascade(label="My Profile", menu=menu3)
                                
                menu4 = Menu(menubar, tearoff=0)
                menu4.add_command(label="About bmTraces", command=self.about)
                menubar.add_cascade(label="Help", menu=menu4)

                self.fenetre.config(menu=menubar)


                
        def authBox(self):
                try: 
                        res = authDialog(self.fenetre)
                        
                except TypeError:
                        Alert().showinfo('Sorry for you', 'All fields must be filled !!')
                        
                try:
                        #Sqlite search in users.db
                        if res.result[0]: 
                                self.thisUser = res.result[0]
                                cDb = sqlQuery(self.usersDb)
                                t = (res.result[0],)
                                password = cDb.selectUser(t)[2]
                                cDb.close()
                                
                                if ( (res.result[1] is not None) and (res.result[1] == password) ) :
                                        log = "Connection : " + res.result[0]
                                        self.trace.add("info", log)
                                        self.me = res.result[0]
                                        self.userOwnDb = self.userOwnDbPath + res.result[0] + ".db"
                                        self.initMenu('ok')
                                        cDb = sqlQuery(self.userOwnDb)
                                        cDb.initUserDb()
                        else:
                                Alert().showinfo('Sorry for you', 'All fields must be filled !!')
                                
                except TypeError:
                        Alert().showinfo('Sorry for you', 'All fields must be filled !!')
                        
                
                
              
        """
        Search in mail log process
        """
        
        def searchBox(self, what):
                try: 
                        self.res = searchDialog(self.fenetre)
                        
                        if (self.res.result[0] and self.res.result[1]):
                                # Step 0 : Display the waiting page
                                self.w = waitForTask()
                                t1=threading.Thread(target=self.searchProcess, args=(self.res, what))
                                t1.start()
                                self.w.start() 
                                t1.join()
                        else:
                                Alert().showinfo('Sorry for you', 'All fields must be filled !!')
                        
                except:
                        pass        
                        
        def searchProcess(self, res, what):
                self.res = res
                if self.res.result[0]:
                        # Step 1 : Parse the file
                        
                        log = "Request by : " + self.thisUser + ", Action : Search " + what + ", String : " + res.result[1]
                        self.trace.add("info", log)

                        p = mailLogParser(self.userOwnDb, res.result[0], what, res.result[1])
                        p.getFileContent()
                        #try:
                                #thread.start_new_thread(p.parseContent())
                                #thread.start_new_thread(p.parseContent())
                                #thread.start_new_thread(p.parseContent())
                                #thread.start_new_thread(p.parseContent())
                                #thread.start_new_thread(p.parseContent())
                                #thread.start_new_thread(p.parseContent())
                        #except:
                                #print "Error : unable to start thread"
                        
                        p.parseContent()
                        
                        nbEntry = int(p.getCountEntry()[0])
                        p.closeSQL()

                        
                        if nbEntry > 0:
                                # Step 2 : init the 2 panes, left for list of msg, right for details
                                titleLeft  = "  List of message(s)  "
                                titleRight = "  Details  "
                                
                                i2f = initFrames(self.fenetre)
                                i2f.init2Frames(case="log", titleLeftLabelFrame=titleLeft, titleRightLabelFrame=titleRight,)        
                                                                
                                # Step 3 : search in db
                                cas = (what, '%'+res.result[1]+'%')
                                l = viewData(self.userOwnDb, i2f.frameL, i2f.frameR)
                                l.getList(cas)
                                        
                                # Step 4 : display list and details
                                self.backgroundImg.forget()
                                l.displayList()
                                self.w.stop() 
                                
                        else:
                                self.w.stop() 
                                Alert().showinfo('Sorry for you', 'No entry found !!')
                                
         
         
        """ 
        User/Account management
        """
        
        def bmTraceUsersList(self,**kwargs):
                
                self.backgroundImg.forget()
                
                if "parent" in kwargs.keys():
                        parentW = kwargs["parent"]
                else:
                        parentW = self.fenetre
               
                bmu = bmTraceUsers(parent=parentW, me=self.me)
                bmu.showAllUser()
                        
       
       
        def bmTraceEditMyProfile(self,*args, **kwargs):
                self.backgroundImg.forget()
                
                if "parent" in kwargs.keys():
                        parentW = kwargs["parent"]
                else:
                        parentW = self.fenetre
                        
                bmu = bmTraceUsers(parent=parentW)
                bmu.displayPasswordForm(user=args[0], me=self.me)             
                
                
        def bmTraceAddUser(self,*args, **kwargs):
                
                self.backgroundImg.forget()
                
                if "parent" in kwargs.keys():
                        parentW = kwargs["parent"]
                else:
                        parentW = self.fenetre
                        
                bmu = bmTraceUsers(parent=parentW, me=self.me)
                bmu.displayAddUserForm()
         
                
