#!/usr/bin/env python
# -*- coding: utf-8 -*-

"""
 * ------------------------------------------------------------------------
 * bmTraces
 * ------------------------------------------------------------------------
 * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>
 * @author  : Pascal SALAUN 
 * @Website : http://www.bm-stats.org <http://www.bm-stats.org>
 * ------------------------------------------------------------------------
"""

# Native Python Lib/Class 
from Tkinter import * 
import ttk


class initFrames:

        def  __init__(self, parent):
                self.fenetre = parent


        def init1Frame(self, **kwargs):
                        
                # Destroy All PanedWindow opened before in self.fenetre
                for instance in self.fenetre.winfo_children():
                        if isinstance(instance, PanedWindow):
                                instance.destroy()
                        if isinstance(instance, ttk.Notebook):
                                instance.destroy()
                                
                                

                self.pane = PanedWindow(self.fenetre, orient=HORIZONTAL, sashrelief="sunken")
                self.pane.pack(fill=BOTH, expand=1)
                self.pane.config(bd=2, sashpad=5, bg="white")




        def init2Frames(self, **kwargs):
                
                if "titleLeftLabelFrame" in kwargs.keys():
                        titleLeftLabelFrame = kwargs["titleLeftLabelFrame"]
                else:
                        titleLeftLabelFrame = "   Liste   "
                        
                
                if "titleRightLabelFrame" in kwargs.keys():
                        titleRightLabelFrame = kwargs["titleRightLabelFrame"]
                else:
                        titleRightLabelFrame = "   Details   "
                        
                
                if "case" in kwargs.keys():
                        case = kwargs["case"]
                else:
                        case = "log"
                
                """
                Memento : 
                Labelframes don't support scrolling. 
                However, there is a simple solution. 
                First, add a canvas as a child to the labelframe and pack it so that it fills the labelframe. 
                Attach scrollbars to the canvas and add them to the labelframe too. 
                Then embed a frame within the canvas, add your widgets to that inner frame, 
                and then adjust the scrollregion of the canvas to match the size of the frame after you've
                added all the inner labels and entries.
                """
                
                # Destroy All PanedWindow opened before in self.fenetre
                for instance in self.fenetre.winfo_children():
                        if isinstance(instance, PanedWindow):
                                        instance.destroy()
                
                self.pane = PanedWindow(self.fenetre, orient=HORIZONTAL, sashrelief="sunken")
                self.pane.pack(fill=BOTH, expand=1)
                self.pane.config(bd=2, sashpad=5, bg="white")
                
                """
                All about the left pannel        
                """
                
                self.left = left = self.frameL = LabelFrame(self.pane, text=titleLeftLabelFrame, bg="white")
                self.pane.add(self.left)
                self.pane.paneconfigure(self.left, minsize=450, sticky="nsew")
                
                
                if case == "log":
                        """
                        All about the right pannel
                        vsbR : vertical scrollbar Right
                        """        
                        def _configure_frameR(event):
                                # update the scrollbars to match the size of the inner frame
                                size = (frameR.winfo_reqwidth(), frameR.winfo_reqheight())
                                canvasR.config(scrollregion="0 0 %s %s" % size)
                                if frameR.winfo_reqwidth() != canvasR.winfo_width():
                                        # update the canvas's width to fit the inner frame
                                        canvasR.config(width=frameR.winfo_reqwidth())
                        
                        self.right = right = LabelFrame(self.pane, text=titleRightLabelFrame, bg="white")
                        self.pane.add(self.right, minsize=650, sticky="nsew")
                        
                        """See Memento """
                        canvasR = Canvas(right, borderwidth=0)
                        self.frameR = frameR = Frame(canvasR, bg="white")
                        vsbR = Scrollbar(right, orient="vertical", command=canvasR.yview)
                        canvasR.configure(yscrollcommand=vsbR.set, width=650, bg="white", bd=0)       
                        vsbR.pack(side="right", fill="y")
                        canvasR.pack(side="left", fill="both", expand=True)
                        canvasR.create_window((4,4), window=frameR, anchor="nw", tags="frameR")
                        
                        frameR.bind('<Configure>', _configure_frameR)
                        
                else:
                        self.right = right = self.frameR = Frame(self.pane, bg="white")
                        self.pane.add(self.right, minsize=650, sticky="nsew")


